
-- VHDL Test Bench Created from source file biquad_test1.vhd -- 17:41:09 03/05/2006
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY util_core_tb IS
END util_core_tb;

ARCHITECTURE behavior OF util_core_tb IS 

	COMPONENT util_core
	PORT(
		clk : IN std_logic;
		res : IN std_logic;
		input : IN signed(31 downto 0);
		opcode : IN std_logic_vector(3 downto 0);
		am_adr : IN std_logic_vector(8 downto 0);
		cm_adr : IN std_logic_vector(8 downto 0);
		enable : IN std_logic;
		dmi_adr : IN std_logic_vector(10 downto 0);
		dmi_wdata : IN std_logic_vector(7 downto 0);
		dmi_wen : IN std_logic;
		dmi_en : IN std_logic;
		mmi_en : IN std_logic;
		wmi_en : IN std_logic;    
		sri_data : INOUT std_logic_vector(15 downto 0);      
		output : OUT signed(31 downto 0);
		ready : OUT std_logic;
		sri_addr : OUT std_logic_vector(17 downto 0);
		sri_cs1 : OUT std_logic;
		sri_cs2 : OUT std_logic;
		sri_oe : OUT std_logic;
		sri_ub : OUT std_logic;
		sri_lb : OUT std_logic;
		sri_we : OUT std_logic;
		dmi_rdata : OUT std_logic_vector(7 downto 0);
		mmi_rdata : OUT std_logic_vector(7 downto 0);
		wmi_rdata : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	COMPONENT ram256k16
	    port ( addr : in    std_logic_vector (17 downto 0);
	           data : inout std_logic_vector (15 downto 0);
	           ce   : in std_logic;
	           we   : in std_logic;
	           oe   : in std_logic;
	           lb   : in std_logic;
	           ub   : in std_logic                                            
	         );
	end COMPONENT;



	SIGNAL clk 			:  std_logic;
	SIGNAL res 			:  std_logic;
	SIGNAL input1 		:  signed(31 downto 0);
	SIGNAL input2 		:  signed(31 downto 0);
	SIGNAL output1 	:  signed(31 downto 0);
	SIGNAL output2 	:  signed(31 downto 0);
	SIGNAL enable 	:  std_logic;
	SIGNAL ready 	:  std_logic;	

--	SIGNAL input1sl 		:  std_logic_vector(23 downto 0);
--	SIGNAL input2sl 		:  std_logic_vector(23 downto 0);
--	SIGNAL output1sl 	:  std_logic_vector(23 downto 0);
--	SIGNAL output2sl 	:  std_logic_vector(23 downto 0);

	SIGNAL input1sl 		:  std_logic_vector(31 downto 0);
	SIGNAL input2sl 		:  std_logic_vector(31 downto 0);
	SIGNAL output1sl 	:  std_logic_vector(31 downto 0);
	SIGNAL output2sl 	:  std_logic_vector(31 downto 0);


	constant T_RESET 		: time :=  1 ns;
	constant T_CLK_PER 	: time := 20 ns;
	
--	constant N_MULTIPLY_TO_SR : integer := 1042;  -- ca. 20.83 us => 48000kHz
 	constant N_MULTIPLY_TO_SR : integer := 300;  -- fr simulation und test (geht schneller)
	
	SIGNAL value :  std_logic_vector (31 downto 0);
	SIGNAL incr  :  std_logic_vector (31 downto 0);	

	SIGNAL opcode :  std_logic_vector (3 downto 0);
	SIGNAL am_adr :  std_logic_vector (8 downto 0);	
	SIGNAL cm_adr :  std_logic_vector (8 downto 0);

	
	SIGNAL input_8_1   :  signed (7 downto 0);		
	SIGNAL input_8_2   :  signed (7 downto 0);		
	SIGNAL output_8_1  :  signed (7 downto 0);		
	SIGNAL output_8_2  :  signed (7 downto 0);		

   signal temp  : std_logic_vector (31 downto 0);
   
   signal temp2 : std_logic_vector (7 downto 0);   


	SIGNAL sri_addr :  std_logic_vector (17 downto 0);
	SIGNAL sri_data :  std_logic_vector (15 downto 0);
	SIGNAL sri_ce		: std_logic;
	SIGNAL sri_we		: std_logic;
	SIGNAL sri_oe		: std_logic;
	SIGNAL sri_lb		: std_logic;
	SIGNAL sri_ub		: std_logic;


BEGIN
    
--   input1sl  <= std_logic_vector (input1 (23 downto 0)); 
--   input2sl  <= std_logic_vector (input1 (23 downto 0));  
   
--   output1 <= signed (output1sl (23) & output1sl (23) & output1sl (23) & output1sl (23) & 
--                      output1sl (23) & output1sl (23) & output1sl (23) & output1sl (23) & output1sl (23 downto 0));
--   output2 <= signed (output2sl (23) & output2sl (23) & output2sl (23) & output2sl (23) & 
--                      output2sl (23) & output2sl (23) & output2sl (23) & output2sl (23) & output2sl (23 downto 0));

--   input1sl <= std_logic_vector (input1);
--   input2sl <= std_logic_vector (input2);   
   
--   output1 <= signed (output1sl);
--   output2 <= signed (output2sl);   

--	Inst_util_core: util_core PORT MAP(
--		clk 		=> clk,
--		res 		=> res,
--		input 	=> input1,
--		output 	=> output1,
--		opcode 	=> opcode,
--		am_adr 	=> am_adr,
--		cm_adr 	=> cm_adr,
--		enable 	=> enable,
--		ready 	=> ready,
--	 	
--		dmi_adr		=> (others => '0'),
--	 	dmi_wdata	=> (others => '0'),
--	 	dmi_rdata	=> open,
--	 	dmi_wen		=> '0',
--	 	dmi_en		=> '0',
--
--	 	wmi_adr		=> (others => '0'),
--	 	wmi_wdata	=> (others => '0'),
--	 	wmi_rdata	=> open,
--	 	wmi_wen		=> '0',
--	 	wmi_en		=> '0'
--		);


	Inst_ram_256k : ram256k16 port map (
		addr 			=> sri_addr,
		data 			=> sri_data,
		ce   			=> sri_ce,
		we   			=> sri_we,
		oe   			=> sri_oe,
		lb   			=> sri_lb, 
		ub   			=> sri_ub
	);



	Inst_util_core: util_core PORT MAP(
		clk 			=> clk,
		res 			=> res,
			
		input 		=> input1,
		output 		=> output1,
		opcode 		=> opcode,
		am_adr 		=> am_adr,
		cm_adr 		=> cm_adr,
		enable 		=> enable,
		ready 		=> ready,

		sri_data 	=> sri_data,
		sri_addr 	=> sri_addr,
		sri_cs1 	=> sri_ce,
		sri_cs2 	=> open,
		sri_oe 		=> sri_oe,
		sri_ub 		=> sri_ub,
		sri_lb 		=> sri_lb,
		sri_we 		=> sri_we,

		dmi_adr 	=> (others => '0'),
		dmi_wdata => (others => '0'),
		dmi_wen 	=> '0',

		dmi_rdata => open,
		dmi_en 		=> '0',

		mmi_rdata => open,
		mmi_en 		=> '0',

		wmi_rdata => open,
		wmi_en 		=> '0'
	);

  clkgen : PROCESS
  BEGIN
      clk <= '0';
		wait for T_RESET;
		clkloop : loop
		  clk <= '1';
		  wait for T_CLK_PER / 2;
		  clk <= '0';		  
		  wait for T_CLK_PER / 2;
		end loop;
  END PROCESS;


	resgen : PROCESS
	BEGIN
	   res <= '1';
		wait for T_RESET;
		res <= '0';
	  wait; -- will wait forever
	END PROCESS;

	datagen : PROCESS
	
	
	    procedure calc_sample is
	      variable temp  : std_logic_vector (31 downto 0);
	      variable temp8 : std_logic_vector ( 7 downto 0);
	        
	    begin
	     	value <= value + incr;
 		   	temp  := std_logic_vector (value) - X"80000000";
	     	if temp (31) = '1' then
          input1 <= signed (X"ff" & temp (31) & temp (31 downto 9));
          input2 <= signed (X"ff" & temp (31) & temp (31 downto 9));
        else  
          input1 <= signed (X"00" & temp (31) & temp (31 downto 9));
          input2 <= signed (X"00" & temp (31) & temp (31 downto 9));
       	end if;  
       	temp8 := std_logic_vector (input1 (23 downto 16)) + X"80";
       	input_8_1 <=  signed (temp8);
       	temp8 := std_logic_vector (input2 (23 downto 16)) + X"80";
       	input_8_2 <=  signed (temp8);
	    end calc_sample;   

      procedure calc_biquad (opc : in std_logic_vector (3 downto 0)) is
        variable temp : std_logic_vector (7 downto 0);
      begin 	
			opcode <= opc;
		  enable <= '1';
		  wait for T_CLK_PER;
		  enable <= '0';
		  wait for T_CLK_PER * 19;
		  temp := std_logic_vector (output1 (23 downto 16)) - X"80";
		  output_8_1 <= signed (temp);
		  temp := std_logic_vector (output2 (23 downto 16)) - X"80";
		  output_8_2 <= signed (temp);
		  opcode <= X"0";
	   end calc_biquad;
	   
	   variable c : integer;
	
	BEGIN
	   c := 0;  
	   enable <= '0'; 
	   value  <= (others => '0');
	   incr   <= X"00000000";
		 opcode <= X"0";
		 am_adr <= '0' & X"00";
		 cm_adr <= '0' & X"00";
	   
		wait for T_RESET;

		input1   <= X"00800000";
		input2   <= X"00800000";

		wait for T_CLK_PER * 5;

      datagenloop : loop 
        c := c + 1;
        if c = 450 then

        end if;  
        calc_sample;
        calc_biquad (X"3");
        --calc_biquad (X"3");
        
		  wait for T_CLK_PER * (N_MULTIPLY_TO_SR  - 40);
        
      end loop;  

	END PROCESS;


END;
